/*** Configurations ***/
var baseurl="";
var feedbackurl="http://_FEEDBACKURL_";
var searchurl="http://_SOLRURL_/_SOLRCORE_/select";
var autocompleteurl="http://_SOLRURL_/_SOLRCORE_/select";

/*Piwik analytics plugin*/
var statid=""; //if empty, the stats are not loaded
var staturl="_STATURL_/piwik"; // Without http://


/*** Core script ***/
$(document).ready(function(){	
	
	/* Datatables */
	var i=0;
	$('#tbl thead tr').clone().appendTo('#tbl thead')
	$('#tbl').DataTable({
		"language":{"url":baseurl+"/registry/res/js/data-table-languages/"+lng+".json"},
		"jQueryUI":true,
		"pagingType":"full_numbers",
		"displayLength":50,
        "stateSave": true,
		"initComplete": function () {
			$('#tbl thead tr:first th').css('text-align','left')
			$('#tbl thead tr:first th').each( function () {
				var title = $('#tbl thead th').eq( $(this).index() ).text();
				var filter = $('#tbl_filter label').text()
				$(this).html( '<input clasS="fin'+(i++)+'" type="text" placeholder="'+filter+' '+title+'" />' );
				$(this).css('padding','5px 0')
			});			
			var api = this.api();
			var state = api.state.loaded();
			if(state){
				api.columns().eq(0).each(function(idx) {
					var colSearch = state.columns[idx].search;	
					$('input.fin'+idx).val(colSearch.search);
					$('input.fin'+idx).on('keyup change',function(){
						api.column(idx).search(this.value).draw();
					} );
				} );
			}
		}
	});
		
	/* Localization */
	$.getJSON(baseurl+'/registry/service/getSessionLang.php', function(data) {
		a = data.lang;
		if(a==null || a==''){
			a = $('html').attr('lang');
			$.getJSON(baseurl+'/registry/service/switch.php?lang='+a, function(data) {});
		}
		
		if(a!=null && a!='' && a!=$('html').attr('lang')){
			$('html').attr("lang",a);
			var u = location.href;			
			u = (u.indexOf("#")>0) ? u.substring(0,u.indexOf("#")) : u;
			u = (u.indexOf("?")>0) ? u.substring(0,u.indexOf("?")) : u;
			var u1 = u.substring(0,u.lastIndexOf("/"));
			var u2 = u1.substring(u1.lastIndexOf("/")+1);
			var u3=u+u2+"."+a+".html";
			
			/* Second level handler */
			if(!isNaN(u2)){
					u1 = u1.substring(0,u1.lastIndexOf("/"));
					u2 = u1.substring(u1.lastIndexOf("/")+1);
					u3=u+u2+"."+a+".html"
			}

			/* Versions handler  */
			if(u.match(/:([0-255])/)){
					u1 = u.substring(0,u.lastIndexOf(":"));
					u2 = u1.substring(u1.lastIndexOf("/")+1);
					u3=u+u2+"."+a+".html";
					u3=u3.replace(/:([0-255])/g, "/$1/");
			}
			
			u3=u3.replace("codeList","codelist");
			u3=u3.replace("applicationSchema","applicationschema");	
		
			$('body').load(u3);
		}
	});	
	$("#lngm").val($("html").attr("lang"));
	$("title").html($("article.exp h2").text());
	
	/* Right menu */	
	$(".dxbox").mouseenter(function(){$(this).filter(':not(:animated)').animate({width:'150px'}, 200);});
	$(".dxbox").mouseleave(function(){$(this).animate({width:'0px'}, 200);});
	$(".searchb").click(function(){location.href=baseurl+'/registry/search/'});
	$(".help").click(function(){helpDialog.load(baseurl+'/registry/help/help.'+lng+'.html').dialog('open');});
	$(".rss").click(function(){location.href=baseurl+'/registry/rss/'});
    $(".com").click(function(){comDialog.load(baseurl+'/registry/service/community.php').dialog('open');});
	$(".feedback").click(function(){
		fdbDialog.html('<iframe class="ld" src="'+feedbackurl+'" />').dialog('open');
	});

	/* Top right menu*/
	$("#about").click(function(){aboutDialog.load(baseurl+'/registry/about/about.'+lng+'.html').dialog('open');});
	
	/* Dialogs */
	var helpDialog = $("#helpd").dialog({autoOpen:false,height:500,width:650,modal:true});
	var aboutDialog = $("#aboutd").dialog({autoOpen:false,height:500,width:650,modal:true});
	var fdbDialog = $("#fdbd").dialog({autoOpen:false,height:500,width:650,modal:true});
        var comDialog = $("#comd").dialog({autoOpen:false,height:600,width:650,modal:true});
	
});

/*Change language*/
function sc(){
	var str="";
	$("select#lngm option:selected").each(function (){str=$(this).val()});
	if(str!=$("html").attr("lang")){
		$.ajax({
			url:baseurl+"/registry/service/switch.php?lang="+str,
			success:function(){window.location.reload()}
		});
	}
}

/*Mobile compatibility*/
function checkViewport(){
	if ($(window).width() < 1080) { $('meta[name=viewport]').attr('content','initial-scale=0.54'); }
}
checkViewport();
$( window ).on( "orientationchange", function( event ) {
	checkViewport();
})

function setTableCsv(name){
	window.setTimeout(function(){
		$("div#tbl_length").append('<a class="csvsmall" href="'+name+'"></a>');
	},200);
}