<?xml version="1.0" encoding="ISO-8859-1"?>

<!--  Copyright 2010,2015 EUROPEAN UNION
  Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
  the European Commission - subsequent versions of the EUPL (the "Licence");
  You may not use this work except in compliance with the Licence.
  You may obtain a copy of the Licence at:
 
  http://ec.europa.eu/idabc/eupl
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the Licence is distributed on an "AS IS" basis,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the Licence for the specific language governing permissions and
  limitations under the Licence.
 
  Date: 30/03/2015
  Authors: European Commission, Joint Research Centre
  Daniele Francioli, Emanuela Epure
  inspire-registry-dev@jrc.ec.europa.eu
 
This work was supported by the EU  Interoperability Solutions for
European Public Administrations Programme (http://ec.europa.eu/isa)
through Action 1.17: Re-usable INSPIRE Reference Platform 
(http://ec.europa.eu/isa/actions/01-trusted-information-exchange/1-17action_en.htm).-->

<xsl:stylesheet version="2.0" 
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xmlns="http://inspire.ec.europa.eu/registry"> 
    
    <!--Output settings-->
    <xsl:output method="xml" media-type="application/xml" version="1.0" encoding="UTF-8" indent="yes"/>

    <!--Variables & parameters declaration-->
    <xsl:param name="base_db_export_path" />
    
    <xsl:template match="/">
        <registry xsi:schemaLocation="http://inspire.ec.europa.eu/registry http://inspire.ec.europa.eu/draft-schemas/registry/1.0/registry.xsd">
            <xsl:apply-templates select="registry"/>
        </registry>
    </xsl:template>
    
    <xsl:template match="registry">
        
        <xsl:attribute name="id">
            <xsl:value-of select="uri"/>
        </xsl:attribute>
        
        <xsl:variable name="language" select="language/isocode"></xsl:variable>  
        <xsl:element name="language" >
            <xsl:value-of select="$language" />
        </xsl:element>
        
        <xsl:if test="label != ''">
            <xsl:element name="label" >
                <xsl:attribute name="xml:lang">
                    <xsl:variable name="language" select="label/@language"></xsl:variable>
                    <xsl:value-of select="label/@language"/>
                </xsl:attribute>
                <xsl:value-of select="label" />
            </xsl:element>
        </xsl:if>
        
        <xsl:if test="definition != ''">
            <xsl:variable name="tmp" select="definition"/>
            
            <xsl:element name="contentsummary" >
                <xsl:attribute name="xml:lang">
                    <xsl:value-of select="definition/@language"/>
                </xsl:attribute>
                <xsl:value-of select="$tmp" />
            </xsl:element>        
        </xsl:if>
        
        <xsl:if test="description != ''">
            <xsl:variable name="tmp" select="description"/>
             
            <xsl:element name="description" >
                <xsl:attribute name="xml:lang">
                    <xsl:value-of select="description/@language"/>
                </xsl:attribute>
                <xsl:value-of select="$tmp" />
            </xsl:element>        
        </xsl:if>
        
        <xsl:if test="registrymanager != ''">
            <xsl:element name="registrymanager" >
                <xsl:attribute name="xml:lang">
                    <xsl:value-of select="registrymanager/label/@language"/>
                </xsl:attribute>
                <xsl:value-of select="registrymanager/label" />
            </xsl:element>
        </xsl:if>

        
        <xsl:choose>
            <xsl:when test="registers">
                <xsl:element name="registers" >
                    <xsl:for-each select="registers/register">
                
                        <xsl:element name="register" >
                            
                            <xsl:attribute name="id">
                                <xsl:value-of select="uri"/>
                            </xsl:attribute>
                    
                            <xsl:if test="label != ''">
                                <xsl:element name="label" >
                                    <xsl:attribute name="xml:lang">
                                        <xsl:value-of select="label/@language"/>
                                    </xsl:attribute>
                                    <xsl:value-of select="label" />
                                </xsl:element>
                            </xsl:if>
                    
                        </xsl:element>   

                    </xsl:for-each>
                </xsl:element>
        
            </xsl:when>
            <xsl:otherwise>
            </xsl:otherwise>
        </xsl:choose>
        
    </xsl:template>
</xsl:stylesheet>