/*
 * Copyright 2010,2015 EUROPEAN UNION
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://ec.europa.eu/idabc/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * Date: 30/03/2015
 * Authors: European Commission, Joint Research Centre
 * Daniele Francioli, Emanuela Epure
 * inspire-registry-dev@jrc.ec.europa.eu
 *
 * This work was supported by the EU  Interoperability Solutions for
 * European Public Administrations Programme (http://ec.europa.eu/isa)
 * through Action 1.17: Re-usable INSPIRE Reference Platform 
 */
package eu.europa.ec.re3gistrycommon.model;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;


@Entity
@Table(name = "procedurestatus")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Procedurestatus.findAll", query = "SELECT p FROM Procedurestatus p"),
    @NamedQuery(name = "Procedurestatus.findByUuid", query = "SELECT p FROM Procedurestatus p WHERE p.uuid = :uuid"),
    @NamedQuery(name = "Procedurestatus.findByLabel", query = "SELECT p FROM Procedurestatus p WHERE p.label = :label")})
public class Procedurestatus implements Serializable {
    
    
    
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "uuid")
    private String uuid;
    @Basic(optional = false)
    @Column(name = "label")
    private String label;
    
    @OneToMany(mappedBy = "procedurestatus")
    private List<Dataprocedure> dataprocedureList;

    public Procedurestatus() {
    }

    public Procedurestatus(String uuid) {
        this.uuid = uuid;
    }

    public Procedurestatus(String uuid, String label) {
        this.uuid = uuid;
        this.label = label;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (uuid != null ? uuid.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Procedurestatus)) {
            return false;
        }
        Procedurestatus other = (Procedurestatus) object;
        return (this.uuid != null || other.uuid == null) && (this.uuid == null || this.uuid.equals(other.uuid));
    }

    @Override
    public String toString() {
        return "eu.europa.ec.re3gistrycommon.model.Procedurestatus[ uuid=" + uuid + " ]";
    }

    @XmlTransient
    public List<Dataprocedure> getDataprocedureList() {
        return dataprocedureList;
    }

    public void setDataprocedureList(List<Dataprocedure> dataprocedureList) {
        this.dataprocedureList = dataprocedureList;
    }

}
