/*
 * Copyright 2010,2015 EUROPEAN UNION
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://ec.europa.eu/idabc/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * Date: 30/03/2015
 * Authors: European Commission, Joint Research Centre
 * Daniele Francioli, Emanuela Epure
 * inspire-registry-dev@jrc.ec.europa.eu
 *
 * This work was supported by the EU  Interoperability Solutions for
 * European Public Administrations Programme (http://ec.europa.eu/isa)
 * through Action 1.17: Re-usable INSPIRE Reference Platform 
 */
package eu.europa.ec.re3gistrycommon.utils;

import eu.europa.ec.re3gistrycommon.constants.Constants;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import org.apache.log4j.Logger;

public class PersistenceFactory {

    public static EntityManagerFactory getEntityManagerFactory() throws Exception {
        
//Retrieving the persistence unit name
        String persistenceUnitName = Configuration.getInstance().getProperties().getProperty(Constants.KEY_PERSISTENCE_UNIT_NAME, null);
        
        if (persistenceUnitName == null || persistenceUnitName.trim().length() <= 0) {
            throw new Exception("@@ Error while getting the persistence unit name; check the Application.properties file.");
        }

        //Creating the EntityManagerFactory
        return Persistence.createEntityManagerFactory(persistenceUnitName);
    }
}
