/*
 * Copyright 2010,2015 EUROPEAN UNION
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://ec.europa.eu/idabc/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * Date: 30/03/2015
 * Authors: European Commission, Joint Research Centre
 * Daniele Francioli, Emanuela Epure
 * inspire-registry-dev@jrc.ec.europa.eu
 *
 * This work was supported by the EU  Interoperability Solutions for
 * European Public Administrations Programme (http://ec.europa.eu/isa)
 * through Action 1.17: Re-usable INSPIRE Reference Platform 
 * (http://ec.europa.eu/isa/actions/01-trusted-information-exchange/1-17action_en.htm).
 */
package eu.europa.ec.re3gistrystaticizer.jaxbmodelstandard.label;

import eu.europa.ec.re3gistrystaticizer.jaxbmodelstandard.attribute.LabelAttribute;
import eu.europa.ec.re3gistrystaticizer.jaxbmodelstandard.list.CustomattributeValueslList;
import java.io.Serializable;
import java.util.Date;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "customattribute")
@XmlAccessorType(XmlAccessType.FIELD)
public class CustomattributeLabel implements Serializable {

    @XmlElement(name = "name")
    private String name;

    @XmlElement(name = "values")
    private CustomattributeValueslList customattributeValueslList;

    @XmlElement(name = "required")
    private boolean required;
    @XmlElement(name = "multivalue")
    private boolean multivalue;
    @XmlElement(name = "isforeignKey")
    private boolean isforeignKey;
    @XmlElement(name = "coded")
    private boolean coded;

    @XmlElement(name = "datecreation")
    private Date datecreation;
    @XmlElement(name = "datelastupdate")
    private Date datelastupdate;

    public CustomattributeLabel() {
    }

    public CustomattributeValueslList getCustomattributeValueslList() {
        return customattributeValueslList;
    }

    public void setCustomattributeValueslList(CustomattributeValueslList customattributeValueslList) {
        this.customattributeValueslList = customattributeValueslList;
    }

    public Date getDatecreation() {
        return datecreation;
    }

    public void setDatecreation(Date datecreation) {
        this.datecreation = datecreation;
    }

    public Date getDatelastupdate() {
        return datelastupdate;
    }

    public void setDatelastupdate(Date datelastupdate) {
        this.datelastupdate = datelastupdate;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isRequired() {
        return required;
    }

    public void setRequired(boolean required) {
        this.required = required;
    }

    public boolean isMultivalue() {
        return multivalue;
    }

    public void setMultivalue(boolean multivalue) {
        this.multivalue = multivalue;
    }

    public boolean isIsforeignKey() {
        return isforeignKey;
    }

    public void setIsforeignKey(boolean isforeignKey) {
        this.isforeignKey = isforeignKey;
    }

    public boolean getCoded() {
        return coded;
    }

    public void setCoded(boolean coded) {
        this.coded = coded;
    }
}
